<template>
  <form v-bind:action="'/tasks/' + task.id" method="PUT" class="form" v-on:submit="submitForm">
    <div class="form-group">
      <input
        type="text"
        v-model="task.label"
        name="label"
        class="form-control form-control-plaintext"
      />
    </div>
    <div class="form-group">
      <input
        type="date"
        v-model="task.dueDate"
        name="dueDate"
        class="form-control form-control-plaintext"
      />
    </div>
    <div class="form-group">
      <select v-model="task.status" name="status">
          <option disabled value="">Please select an option</option>
          <option value="to-do">To do</option>
          <option value="in-progress">In progress</option>
          <option value="done">Done</option>
      </select>
    </div>
    <div class="form-group">
      <input
        type="text"
        v-model="task.user.name"
        name="userName"
        class="form-control form-control-plaintext"
      />
    </div>
    <div class="form-group">
      <button type="submit" class="btn btn-primary" v-on:click="submitButton">Update</button>
    </div>
  </form>
</template>

<script>
import Axios from "axios";
export default {
  data() {
    return {
      task: null
    };
  },
  mounted() {
    Axios.get("/api/tasks/" + $("datalist").data("task-id")).then(
      response => (this.task = response.data)
    );
  },
  methods: {
    submitButton: function(event) {
      console.log("submit button");
      return;
      $(event.target)
        .closest("form")
        .submit();
    },
    submitForm: function(event) {
      event.preventDefault();
      event.stopPropagation();
      console.log($(event.target).length);
      console.log($(this).serializeArray());
      console.log($(event.target).serializeArray());
      $('div[role="alert"].alert-primary').addClass("d-none");
      $('div[role="alert"].alert-danger').addClass("d-none");

      Axios.put(
        $(event.target).attr("action"),
        $(event.target).serializeArray()
      )
        .then(response => {
          console.log("response ok");
          console.log($('div[role="alert"].alert-primary').length);
          $('div[role="alert"].alert-primary').toggleClass("d-none");
        })
        .catch(err => {
          $('div[role="alert"].alert-primary')
            .show()
            .toggleClass("d-none")
            .html(err);
        });
    }
  }
};
</script>